 title FIX43OFF -- turn off FIX43 resident module

comment #

The cursor in 43 line is fleeting, at best.  The resident FIX43 fixes
that by checking for 8x8 characters every timer interrupt, and if the
EGA is in 8x8 mode, the cursor start and end lines are set to their
proper values.  This program disables FIX43 by finding it and setting
the enable byte to 0.

#

;
; Program segment.
;

fix43off segment
 assume CS:fix43off,DS:fix43off,ES:fix43off,SS:fix43off

;
; Start of .COM code.
 org 100h
start:
  jmp cpyrt
   db 13,'FIX43OFF version 1.0  Copyright (C) 1988  Mark Adler',13,10
   db 'All rights reserved.',13,10,'Z'-64
 cpyrt:
 ;
  mov DX,DS             ;Start checking backwards from this segment.
  cld
 search:
   dec DX
   jz nowhere
   mov SI,offset id     ;Point DS:SI to id string to look for.
   mov ES,DX            ;Point ES:DI to where to look.
   sub DI,DI            ;The id string should be on a 16 byte boundary.
   mov CX,idlen
   repe cmpsb
   jne search           ;If no match, look one back.
  mov AL,0              ;Turn FIX43 off.
  stosb                 ;Enable byte immediately follows id string.
  int 20h               ;Return.

 nowhere:
  mov DX,offset err     ;FIX43 not there---display error message,
  mov AH,9
  int 21h
  int 20h               ; and return.

 id db 'FIX43TSR'
 idlen equ $-id
 err db '?FIX43 not installed',13,10,'$'

fix43off ends

end start
